/**
 * 3DtCgV[eBOQ[ EFFY one of unreasonable "if" pbP[WłB
 *
 * @package_overview
 * @package 	EFFY one of unreasonable "if"
 * @caption		EFFYpbP[W
 * @license 	&lt;a href='http://en.wikipedia.org/wiki/MIT_License'&lt;X11/MIT License&lt;/a&gt;
 * @author		Project ICKX
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5
 * @url 		&lt;a href='http://www.effy.info/'&gt;Project ICKX&lt;/a&gt;
 */

/**
 * EFFYpbP[W EFFY ICE Cu̓AmYǗt@CłB
 *
 * @file_overview
 * @license 	&lt;a href='http://en.wikipedia.org/wiki/MIT_License'&lt;X11/MIT License&lt;/a&gt;
 * @author		Project ICKX
 * @since		1.0
 * @version 	1.0
 * @engine		RSE3.5
 * @url 		&lt;a href='http://www.effy.info/'&gt;Project ICKX&lt;/a&gt;
 */

function initiate_sub_hydrolic_fixer()
{
	initiate_sub_hydrolic_fixer2();
}

function initiate_sub_hydrolic_fixer2()
{
	float current_yaw = 0;
	float current_pitch = 0;
	float current_roll = 0;

	while(TRUE) {
		system();

		if(effy_ice_is_acs_running == TRUE){
			current_yaw = effy_r_s2o_common_lazy_value(current_yaw, 0, 0.01);
			current_pitch = effy_r_s2o_common_lazy_value(current_pitch, 0, 0.01);
			current_roll = effy_r_s2o_common_lazy_value(current_roll, 0, 0.01);
		}
		else {
			current_yaw = effy_r_s2o_common_lazy_value(current_yaw, get_pad_analog_yaw(), 0.1);
			current_pitch = effy_r_s2o_common_lazy_value(current_pitch, get_pad_analog_pitch(), 0.1);
			current_roll = effy_r_s2o_common_lazy_value(current_roll, get_pad_analog_roll(), 0.1);
		}

		fixer2_nozzle(current_pitch, current_roll, current_yaw);
	}
}

function initiate_sub_hydrolic_resonance()
{
	float current_yaw = 0;
	float current_pitch = 0;
	float current_roll = 0;

	while(TRUE) {
		system();

		if (effy_ice_resonance_parking) {
			continue;
		}

		if(effy_ice_is_acs_running == TRUE){
			current_yaw = effy_r_s2o_common_lazy_value(current_yaw, 0, 0.1);
			current_pitch = effy_r_s2o_common_lazy_value(current_pitch, 0, 0.1);
			current_roll = effy_r_s2o_common_lazy_value(current_roll, 0, 0.1);
		}
		else {
			current_yaw = effy_r_s2o_common_lazy_value(current_yaw, get_pad_analog_yaw(), 0.1);
			current_pitch = effy_r_s2o_common_lazy_value(current_pitch, get_pad_analog_pitch(), 0.1);
			current_roll = effy_r_s2o_common_lazy_value(current_roll, get_pad_analog_roll(), 0.1);
		}

		resonance_nozzle(current_pitch, current_roll, current_yaw);
		if (effy_ice_is_acs_running == FALSE) {
			resonance_wing(current_pitch, current_roll, current_yaw);
		}
	}
}

function fixer2_nozzle(float current_pitch, float current_roll, float current_yaw)
{
	float yaw = fixer2_engine_get_nozzle_rot_by_yaw(current_yaw);
	set_rot(EFFY_ICE_LABEL_R_S2O_ENGINE_FLAME_LEFT, fixer2_engine_get_nozzle_rot(current_pitch, current_roll, TRUE), yaw, 0, TRUE);
	set_rot(EFFY_ICE_LABEL_R_S2O_ENGINE_FLAME_RIGHT, fixer2_engine_get_nozzle_rot(current_pitch, current_roll, FALSE), yaw, 0, TRUE);
	set_rot(EFFY_ICE_LABEL_R_S2O_ENGINE_INNER_FLAME_LEFT, 0.5 * fixer2_engine_get_nozzle_rot(current_pitch, current_roll, TRUE), 0.5 * yaw, 0, TRUE);
	set_rot(EFFY_ICE_LABEL_R_S2O_ENGINE_INNER_FLAME_RIGHT, 0.5 * fixer2_engine_get_nozzle_rot(current_pitch, current_roll, FALSE), 0.5 * yaw, 0, TRUE);

}

function float fixer2_engine_get_nozzle_rot(float current_pitch, float current_roll, int engine_right)
{
	float nozzle_rot = 0;
	if (engine_right) {
		nozzle_rot = current_pitch / 2 - current_roll / 1.5;
	}
	else {
		nozzle_rot = current_pitch / 2 + current_roll / 1.5;
	}
	nozzle_rot = -nozzle_rot / 20 * 200;
	if (nozzle_rot > 4.5) {
		nozzle_rot = 4.5;
	}
	else if (nozzle_rot < -4.5) {
		nozzle_rot = -4.5;
	}
	return nozzle_rot;
}

function float fixer2_engine_get_nozzle_rot_by_yaw(float current_yaw)
{
	return -current_yaw / 20 * 100;
}

function resonance_nozzle(float current_pitch, float current_roll, float current_yaw)
{
	float yaw = fixer2_engine_get_nozzle_rot_by_yaw(current_yaw);
	set_rot(EFFY_ICE_LABEL_R_S2O_NOZZLE_LEFT, resonance_engine_get_nozzle_rot(current_pitch, current_roll, TRUE), yaw, 0, TRUE);
	set_rot(EFFY_ICE_LABEL_R_S2O_NOZZLE_RIGHT, resonance_engine_get_nozzle_rot(current_pitch, current_roll, FALSE), yaw, 0, TRUE);

}

function float resonance_engine_get_nozzle_rot(float current_pitch, float current_roll, int engine_right)
{
	float nozzle_rot = 0;
	if (engine_right) {
		nozzle_rot = current_pitch / 2 - current_roll / 1.5;
	}
	else {
		nozzle_rot = current_pitch / 2 + current_roll / 1.5;
	}
	return -nozzle_rot / 20 * 300;
}

function resonance_wing(float current_pitch, float current_roll, float current_yaw)
{
	set_rot(EFFY_ICE_LABEL_R_S2O_RESONACE_CANARD, resonance_wing_get_canard_rot(current_pitch), 0, 0, TRUE);

	set_rot(EFFY_ICE_LABEL_R_S2O_RESONACE_V_WING_LEFT, get_unit_rot_x(EFFY_ICE_LABEL_R_S2O_RESONACE_V_WING_LEFT), resonance_wing_get_wing_rot_y1(current_pitch, current_roll, current_yaw), 50, TRUE);
	set_rot(EFFY_ICE_LABEL_R_S2O_RESONACE_V_WING_RIGHT, get_unit_rot_x(EFFY_ICE_LABEL_R_S2O_RESONACE_V_WING_RIGHT), resonance_wing_get_wing_rot_y2(current_pitch, current_roll, current_yaw), -50, TRUE);
}

function float resonance_wing_get_canard_rot(float current_pitch)
{
	float canard_rot = current_pitch / 2;
	return canard_rot / 20 * 350;
}

function float resonance_wing_get_wing_rot_y1(float current_pitch, float current_roll, float current_yaw)
{
	float wing_rot = current_pitch / 1.5 - current_roll / 1.5 + current_yaw / 3;
	return -wing_rot / 20 * 250;
}

function float resonance_wing_get_wing_rot_y2(float current_pitch, float current_roll, float current_yaw)
{
	float wing_rot = 0 - current_pitch / 1.5 - current_roll / 1.5 + current_yaw / 3;
	return -wing_rot / 20 * 250;
}

